package Apache::CachePOSTRegistry;

use Apache::RegistryNG;
use Apache::Request;
use strict;

@Apache::CachePOSTRegistry::ISA = qw(Apache::RegistryNG);

$Apache::CachePOSTRegistry::VERSION = '0.01';

sub new {

  my ($class, $r) = @_;

  $r = Apache::Request->instance($r || Apache->request);

  tie *STDIN, $class, $r;

  return tied *STDIN;
}

sub READ {

  my $self = shift;
  my $buf = \($_[0]); shift;
  my $len = shift;
  my $offset = shift || 0;

  my $r = $self->{r};

  my @args = ();
  my %query = $r->args;

  $r->param->do(sub {
    my ($key, $value) = @_;
    push @args, join '=', ($key, $value) 
      unless defined $query{$key};
    1;
  });

  my $input = join '&', @args;
  $input =~ s! !+!g;

  substr($$buf, $offset) = substr($input, 0, $len);
  substr($input, 0, $len) = '';
  return length substr($$buf, $offset);
}

sub TIEHANDLE {

  my ($class, $r) = @_;

  return bless { r => $r }, $class;
}
1;
