#!perl

use ExtUtils::MakeMaker;
use Apache::src ();
use Config;

use strict;

my %config;

$config{INC} = Apache::src->new->inc;

if ($^O =~ /Win32/) {
  require Apache::MyConfig;

  $config{DEFINE}  = ' -D_WINSOCK2API_ -D_MSWSOCK_ ';
  $config{DEFINE} .= ' -D_INC_SIGNAL -D_INC_MALLOC '
    if $Config{usemultiplicity};

  $config{LIBS} =
    qq{ -L"$Apache::MyConfig::Setup{APACHE_LIB}" -lApacheCore } .
    qq{ -L"$Apache::MyConfig::Setup{MODPERL_LIB}" -lmod_perl};
}

WriteMakefile(
  NAME         => 'Apache::CachePOSTRegistry',
  VERSION_FROM => 'CachePOSTRegistry.pm',
  PREREQ_PM    => { mod_perl => 1.26, },
  ABSTRACT     => 'Apache::Registry that caches POST data',
  AUTHOR       => 'geoff@cpan.org',
  %config,
);

sub MY::test {
  if (eval "require Apache::TestMM" &&
      eval "require Apache::TestRunPerl") {
    Apache::TestMM->import(qw(test clean));
    Apache::TestMM::filter_args();
    Apache::TestRunPerl->generate_script;
    return Apache::TestMM->test;
  }

  # The whitespace in front of @echo MUST be a single tab!
  return <<'EOF';
test::
\t@echo This test suite requires Apache::Test
\t@echo available from the mod_perl 2.0 sources
\t@echo or the httpd-test distribution.
EOF
}
