use strict;
use warnings FATAL => 'all';

use Apache::Test;
use Apache::TestRequest;
use Apache::TestUtil;

plan tests => 2, have_lwp;

my $v1 = "blah1+blah2+FOO";
my $v2 = "this+is+v2";
my $v3 = "DOOM-GL00m";
my $data = "v1=$v1\&v2=$v2\&v3=$v3";
my $expected = "v1v2v3blah1 blah2 FOOthis is v2DOOM-GL00m";

# Apache::Registry
my $url = '/perl-bin/cgi.cgi';

my $return = POST_BODY $url, content => $data;
ok !t_cmp($expected,
         $return,
         "POST request for $url, content=\"$data\""
        );

# CachePOSTRegistry
$url = '/cache-bin/cgi.cgi';

$return = POST_BODY $url, content => $data;
ok t_cmp($expected,
         $return,
         "POST request for $url, content=\"$data\""
        );

